date
	var
		day = 1
		month = 1
		year = 2000
		second = 1
		minute = 1
		hour = 1
		minute_offset = 0
		hour_offset = 0

	New(_day, _month, _year, _second, _minute, _hour)
		..()
		SetTime(_day, _month, _year, _second, _minute, _hour)


	proc
		SetTime(_day, _month, _year, _second, _minute, _hour)
			if(istext(_day))
				var
					textpath = "/timezone/[_day]"
					path = text2path(textpath)
					timezone/zone = path? new path : null
				if(zone)
					_month = zone.minute_offset
					_year = zone.hour_offset
				else if(_day != "New") return
				minute_offset = _month
				hour_offset = _year
				_year += 8
				FindTime()
				var/list
					old = list(second, minute, hour)
					time
				if(_year <= 0)
					time = SubtractTime(old, 0, abs(_month), abs(_year))
				else
					time = AddTime(old, 0, abs(_month), abs(_year))
				if(time && length(time) >= 3)
					if(length(time) > 3)
						if(time[4] && isnum(time[4]))
							var
								old_date = list(day, month, year)
								new_days = FindDate(AddDays(old_date,time[4]))
							if(new_days && length(new_days) >= 3)
								day = new_days[1]
								month = new_days[2]
								year = new_days[3]
					second = time[1]
					minute = time[2]
					hour = time[3]
			else
				day = _day
				month = _month
				year = _year
				second = _second
				minute = _minute
				hour = _hour
				var/list/valid_date = FindDate(ValidateDate(day,month,year))
				if(valid_date && valid_date.len == 3)
					day = valid_date[1]
					month = valid_date[2]
					year = valid_date[3]

		FindTime()
			var/BYONDTime[] = \
			          world.Export("http://www.developer.byond.com")
			if(BYONDTime)
				BYONDTime = file2text(BYONDTime["CONTENT"])
				var/BST = findText(BYONDTime,"BYOND Standard Time:")
				BYONDTime = copytext(BYONDTime,BST+38)
				var/END = findText(BYONDTime,"</n")
				BYONDTime = copytext(BYONDTime,1,END)
				BYONDTime = dd_text2list(BYONDTime," ")
				if(BYONDTime && istype(BYONDTime,/list))
					day = text2num(BYONDTime[3])
					month = TextMonth2NumMonth(BYONDTime[2])
					year = text2num(time2text(world.realtime,"YYYY"))
					var/colon = findtext(BYONDTime[4],":")
					minute = text2num(copytext(BYONDTime[4],colon+1))
					if(BYONDTime[5] == "PM")
						hour = text2num(copytext(BYONDTime[4],1,colon))+12
					else
						hour = text2num(copytext(BYONDTime[4],1,colon))

		Update()
			FindTime()
			SetTime("New",minute_offset,hour_offset)

		ToText(incoming = "H:mm.ss ?M DD/MM/YYYY")
			var
				H = hour > 12? hour-12 : hour
				ampm = hour > 12? "PM" : "AM"
				monthname = NumMonth2TextMonth(month)
			incoming = dd_replaceText(incoming,"MONTH","[monthname]")
			incoming = dd_replaceText(incoming,"ss",InsertZero(second))
			incoming = dd_replaceText(incoming,"mm",InsertZero(minute))
			incoming = dd_replaceText(incoming,"hh",InsertZero(hour))
			incoming = dd_replaceText(incoming,"H",InsertZero(H))
			incoming = dd_replaceText(incoming,"?M","[ampm]")
			incoming = dd_replaceText(incoming,"DD",InsertZero(day))
			incoming = dd_replaceText(incoming,"MM",InsertZero(month))
			incoming = dd_replaceText(incoming,"YYYY",InsertZero(year,4))
			return incoming

		Add_Days(days, months, years)
			var
				old_date = list(day, month, year)
				new_date= AddDays(old_date, days, months, years)
			new_date = FindDate(new_date)
			if(new_date && length(new_date) > 2)
				day = new_date[1]
				month = new_date[2]
				year = new_date[3]

		Subtract_Days(days, months, years)
			var
				old_date = list(day, month, year)
				new_date = SubtractDays(old_date, days, months, years)
			new_date = FindDate(new_date)
			if(new_date && length(new_date) > 2)
				day = new_date[1]
				month = new_date[2]
				year = new_date[3]

		Add_Time(seconds, minutes, hours)
			var
				old_date = list(second, minute, hour)
				new_date = AddTime(old_date, seconds, minutes, hours)
			if(new_date && length(new_date) > 2)
				second = new_date[1]
				minute = new_date[2]
				hour = new_date[3]
				if(length(new_date) > 3)
					Add_Days(text2num(new_date[4]))

		Subtract_Time(seconds, minutes, hours)
			var
				old_date = list(second, minute, hour)
				new_date = SubtractTime(old_date, seconds, minutes, hours)
			if(new_date && length(new_date) > 2)
				second = new_date[1]
				minute = new_date[2]
				hour = new_date[3]
				if(length(new_date) > 3)
					Subtract_Days(text2num(new_date[4]))

proc/InsertZero(variable,length = 2)
	if(!istext(variable)) variable = "[variable]"
	while(length(variable) < length)
		variable = "0[variable]"
	return "[variable]"