/*Time Functions*/
proc
	ValidateTime(second, minute, hour)
		var/add_day = 0
		while(second >= 60)
			second -= 60
			minute++
		while(minute >= 60)
			minute -= 60
			hour++
		while(hour >= 24)
			hour -= 24
			add_day++
		while(second <= 0)
			minute--
			second += 60
		while(minute <= 0)
			hour--
			minute += 60
		return list(second, minute, hour, add_day)

	AddTime(time, seconds, minutes, hours)
		if(!istype(time,/list)) return
		else if(length(time) < 3) return
		return ValidateTime(time[1]+seconds,time[2]+minutes,time[3]+hours)

	SubtractTime(time, seconds, minutes, hours)
		if(!istype(time,/list)) return
		else if(length(time) < 3) return
		var
			o_second = time[1] - seconds
			o_minute = time[2] - minutes
			o_hour = time[3] - hours
			minus_days = 0
		while(o_hour <= 0)
			o_hour += 24
			minus_days++
		while(o_minute <= 0)
			o_minute += 60
			o_hour--
		while(o_second <= 0)
			o_second += 60
			o_minute--
		return list(o_second, o_minute, o_hour, minus_days)

	SecondsTotal(time)
		if(!istype(time,/list)) return
		else if(length(time) < 3) return
		var
			second = time[1]
			minute = time[2]
			hour = time[3]
		while(hour)
			minute += 60
			hour--
		while(minute)
			second += 60
			minute--
		return second

	SecondsToText(second)
		if(!second || !(isnum(second))) return
		var
			minute = 0
			hour = 0
		. = new/list
		while(second >= 60)
			second -= 60
			minute++
		while(minute >= 60)
			minute -= 60
			hour++
		if(second) . += "[second] Second[second==1?"" : "s"]"
		if(minute) . += "[minute] Minute[minute==1?"" : "s"]"
		if(hour) . += "[hour] Hour[hour==1?"" : "s"]"
		return dd_list2text(.,", ")

	Time_Difference(DateOne, DateTwo)
		if(length(DateOne) < 3 || length(DateTwo) < 3) return
		DateOne = ValidateTime(DateOne[1], DateOne[2], DateOne[3])
		DateTwo = ValidateTime(DateTwo[1], DateTwo[2], DateTwo[3])
		var
			TotalOne= SecondsTotal(list(DateOne[1],DateOne[2],DateOne[3]))
			TotalTwo= SecondsTotal(list(DateTwo[1],DateTwo[2],DateTwo[3]))
		return abs(TotalOne - TotalTwo)